VTK: vtkObjectFactory Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkObjectFactory Class Referenceabstract

abstract base class for vtkObjectFactories More...

`#include <vtkObjectFactory.h>`

Inheritance diagram for vtkObjectFactory:
[legend]
Collaboration diagram for vtkObjectFactory:
[legend]

## Classes
struct | OverrideInformation

## Public Types
typedef vtkObject | Superclass
typedef vtkObject *(* | CreateFunction) ()

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkObjectFactory * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Print ObjectFactory to stream. More...
virtual const char * | GetVTKSourceVersion ()=0
| All sub-classes of vtkObjectFactory should must return the version of VTK they were built with. More...
virtual const char * | GetDescription ()=0
| Return a descriptive string describing the factory. More...
virtual int | GetNumberOfOverrides ()
| Return number of overrides this factory can create. More...
virtual const char * | GetClassOverrideName (int index)
| Return the name of a class override at the given index. More...
virtual const char * | GetClassOverrideWithName (int index)
| Return the name of the class that will override the class at the given index. More...
virtual vtkTypeBool | GetEnableFlag (int index)
| Return the enable flag for the class at the given index. More...
virtual const char * | GetOverrideDescription (int index)
| Return the description for a the class override at the given index. More...
virtual vtkTypeBool | HasOverride (const char *className)
| Return 1 if this factory overrides the given class name, 0 otherwise. More...
virtual vtkTypeBool | HasOverride (const char *className, const char *subclassName)
| Return 1 if this factory overrides the given class name, 0 otherwise. More...
virtual void | Disable (const char *className)
| Set all enable flags for the given class to 0. More...
virtual void | SetEnableFlag (vtkTypeBool flag, const char *className, const char *subclassName)
| Set and Get the Enable flag for the specific override of className. More...
virtual vtkTypeBool | GetEnableFlag (const char *className, const char *subclassName)
| Set and Get the Enable flag for the specific override of className. More...
| vtkGetFilePathMacro (LibraryPath)
| This returns the path to a dynamically loaded factory. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkObject * | CreateInstance (const char *vtkclassname, bool isAbstract=false)
| Create and return an instance of the named vtk object. More...
static void | CreateAllInstance (const char *vtkclassname, vtkCollection *retList)
| Create all possible instances of the named vtk object. More...
static void | ReHash ()
| Re-check the VTK_AUTOLOAD_PATH for new factory libraries. More...
static void | RegisterFactory (vtkObjectFactory *)
| Register a factory so it can be used to create vtk objects. More...
static void | UnRegisterFactory (vtkObjectFactory *)
| Remove a factory from the list of registered factories. More...
static void | UnRegisterAllFactories ()
| Unregister all factories. More...
static vtkObjectFactoryCollection * | GetRegisteredFactories ()
| Return the list of all registered factories. More...
static vtkTypeBool | HasOverrideAny (const char *className)
| return 1 if one of the registered factories overrides the given class name More...
static void | GetOverrideInformation (const char *name, vtkOverrideInformationCollection *)
| Fill the given collection with all the overrides for the class with the given name. More...
static void | SetAllEnableFlags (vtkTypeBool flag, const char *className)
| Set the enable flag for a given named class for all registered factories. More...
static void | SetAllEnableFlags (vtkTypeBool flag, const char *className, const char *subclassName)
| Set the enable flag for a given named class subclass pair for all registered factories. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkObjectFactory * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
void | RegisterOverride (const char *classOverride, const char *overrideClassName, const char *description, int enableFlag, CreateFunction createFunction)
| Register object creation information with the factory. More...
virtual vtkObject * | CreateObject (const char *vtkclassname)
| This method is provided by sub-classes of vtkObjectFactory. More...
| vtkObjectFactory ()
| ~vtkObjectFactory () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
OverrideInformation * | OverrideArray
char ** | OverrideClassNames
int | SizeOverrideArray
int | OverrideArrayLength
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

abstract base class for vtkObjectFactories

vtkObjectFactory is used to create vtk objects. The base class vtkObjectFactory contains a static method CreateInstance which is used to create vtk objects from the list of registered vtkObjectFactory sub-classes. The first time CreateInstance is called, all dll's or shared libraries in the environment variable VTK_AUTOLOAD_PATH are loaded into the current process. The C functions vtkLoad, and vtkGetFactoryVersion are called on each dll. To implement these functions in a shared library or dll, use the macro: VTK_FACTORY_INTERFACE_IMPLEMENT. VTK_AUTOLOAD_PATH is an environment variable containing a colon separated (semi-colon on win32) list of paths.

The vtkObjectFactory can be use to override the creation of any object in VTK with a sub-class of that object. The factories can be registered either at run time with the VTK_AUTOLOAD_PATH, or at compile time with the vtkObjectFactory::RegisterFactory method.

Online Examples:

Tests:
  vtkObjectFactory (Tests)

Definition at line 53 of file vtkObjectFactory.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkObjectFactory::Superclass

Definition at line 127 of file vtkObjectFactory.h.

## ◆ CreateFunction

typedef vtkObject*(* vtkObjectFactory::CreateFunction) ()

Definition at line 206 of file vtkObjectFactory.h.

## Constructor & Destructor Documentation

## ◆ vtkObjectFactory()

vtkObjectFactory::vtkObjectFactory | ( |  | ) |
| protected

## ◆ ~vtkObjectFactory()

vtkObjectFactory::~vtkObjectFactory | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ CreateInstance()

static vtkObject* vtkObjectFactory::CreateInstance | ( | const char * | vtkclassname,
|  | bool | isAbstract = `false`
| ) |  |
| static

Create and return an instance of the named vtk object.

Each loaded vtkObjectFactory will be asked in the order the factory was in the VTK_AUTOLOAD_PATH. After the first factory returns the object no other factories are asked. isAbstract is no longer used. This method calls vtkObjectBase::InitializeObjectBase() on the instance when the return value is non-nullptr.

## ◆ CreateAllInstance()

static void vtkObjectFactory::CreateAllInstance | ( | const char * | vtkclassname,
|  | vtkCollection * | retList
| ) |  |
| static

Create all possible instances of the named vtk object.

Each registered vtkObjectFactory will be asked, and the result will be stored in the user allocated vtkCollection passed in to the function.

## ◆ ReHash()

static void vtkObjectFactory::ReHash | ( |  | ) |
| static

Re-check the VTK_AUTOLOAD_PATH for new factory libraries.

This calls UnRegisterAll before re-loading

## ◆ RegisterFactory()

static void vtkObjectFactory::RegisterFactory | ( | vtkObjectFactory * |  | ) |
| static

Register a factory so it can be used to create vtk objects.

## ◆ UnRegisterFactory()

static void vtkObjectFactory::UnRegisterFactory | ( | vtkObjectFactory * |  | ) |
| static

Remove a factory from the list of registered factories.

## ◆ UnRegisterAllFactories()

static void vtkObjectFactory::UnRegisterAllFactories | ( |  | ) |
| static

Unregister all factories.

## ◆ GetRegisteredFactories()

static vtkObjectFactoryCollection* vtkObjectFactory::GetRegisteredFactories | ( |  | ) |
| static

Return the list of all registered factories.

This is NOT a copy, do not remove items from this list!

## ◆ HasOverrideAny()

static vtkTypeBool vtkObjectFactory::HasOverrideAny | ( | const char * | className | ) |
| static

return 1 if one of the registered factories overrides the given class name

## ◆ GetOverrideInformation()

static void vtkObjectFactory::GetOverrideInformation | ( | const char * | name,
|  | vtkOverrideInformationCollection * |
| ) |  |
| static

Fill the given collection with all the overrides for the class with the given name.

## ◆ SetAllEnableFlags() [1/2]

static void vtkObjectFactory::SetAllEnableFlags | ( | vtkTypeBool | flag,
|  | const char * | className
| ) |  |
| static

Set the enable flag for a given named class for all registered factories.

## ◆ SetAllEnableFlags() [2/2]

static void vtkObjectFactory::SetAllEnableFlags | ( | vtkTypeBool | flag,
|  | const char * | className,
|  | const char * | subclassName
| ) |  |
| static

Set the enable flag for a given named class subclass pair for all registered factories.

## ◆ IsTypeOf()

static vtkTypeBool vtkObjectFactory::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkObjectFactory::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkObjectFactory* vtkObjectFactory::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkObjectFactory::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkObjectFactory* vtkObjectFactory::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkObjectFactory::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Print ObjectFactory to stream.

Reimplemented from vtkObject.

## ◆ GetVTKSourceVersion()

virtual const char* vtkObjectFactory::GetVTKSourceVersion | ( |  | ) |
| pure virtual

All sub-classes of vtkObjectFactory should must return the version of VTK they were built with.

This should be implemented with the macro VTK_SOURCE_VERSION and NOT a call to vtkVersion::GetVTKSourceVersion. As the version needs to be compiled into the file as a string constant. This is critical to determine possible incompatible dynamic factory loads.

## ◆ GetDescription()

virtual const char* vtkObjectFactory::GetDescription | ( |  | ) |
| pure virtual

Return a descriptive string describing the factory.

## ◆ GetNumberOfOverrides()

virtual int vtkObjectFactory::GetNumberOfOverrides | ( |  | ) |
| virtual

Return number of overrides this factory can create.

## ◆ GetClassOverrideName()

virtual const char* vtkObjectFactory::GetClassOverrideName | ( | int | index | ) |
| virtual

Return the name of a class override at the given index.

## ◆ GetClassOverrideWithName()

virtual const char* vtkObjectFactory::GetClassOverrideWithName | ( | int | index | ) |
| virtual

Return the name of the class that will override the class at the given index.

## ◆ GetEnableFlag() [1/2]

virtual vtkTypeBool vtkObjectFactory::GetEnableFlag | ( | int | index | ) |
| virtual

Return the enable flag for the class at the given index.

## ◆ GetOverrideDescription()

virtual const char* vtkObjectFactory::GetOverrideDescription | ( | int | index | ) |
| virtual

Return the description for a the class override at the given index.

## ◆ SetEnableFlag()

virtual void vtkObjectFactory::SetEnableFlag | ( | vtkTypeBool | flag,
|  | const char * | className,
|  | const char * | subclassName
| ) |  |
| virtual

Set and Get the Enable flag for the specific override of className.

if subclassName is null, then it is ignored.

## ◆ GetEnableFlag() [2/2]

virtual vtkTypeBool vtkObjectFactory::GetEnableFlag | ( | const char * | className,
|  | const char * | subclassName
| ) |  |
| virtual

Set and Get the Enable flag for the specific override of className.

if subclassName is null, then it is ignored.

## ◆ HasOverride() [1/2]

virtual vtkTypeBool vtkObjectFactory::HasOverride | ( | const char * | className | ) |
| virtual

Return 1 if this factory overrides the given class name, 0 otherwise.

## ◆ HasOverride() [2/2]

virtual vtkTypeBool vtkObjectFactory::HasOverride | ( | const char * | className,
|  | const char * | subclassName
| ) |  |
| virtual

Return 1 if this factory overrides the given class name, 0 otherwise.

## ◆ Disable()

virtual void vtkObjectFactory::Disable | ( | const char * | className | ) |
| virtual

Set all enable flags for the given class to 0.

This will mean that the factory will stop producing class with the given name.

## ◆ vtkGetFilePathMacro()

vtkObjectFactory::vtkGetFilePathMacro | ( | LibraryPath |  | ) |

This returns the path to a dynamically loaded factory.

## ◆ RegisterOverride()

void vtkObjectFactory::RegisterOverride | ( | const char * | classOverride,
|  | const char * | overrideClassName,
|  | const char * | description,
|  | int | enableFlag,
|  | CreateFunction | createFunction
| ) |  |
| protected

Register object creation information with the factory.

## ◆ CreateObject()

virtual vtkObject* vtkObjectFactory::CreateObject | ( | const char * | vtkclassname | ) |
| protectedvirtual

This method is provided by sub-classes of vtkObjectFactory.

It should create the named vtk object or return 0 if that object is not supported by the factory implementation.

## Member Data Documentation

## ◆ OverrideArray

OverrideInformation* vtkObjectFactory::OverrideArray
| protected

Definition at line 233 of file vtkObjectFactory.h.

## ◆ OverrideClassNames

char** vtkObjectFactory::OverrideClassNames
| protected

Definition at line 234 of file vtkObjectFactory.h.

## ◆ SizeOverrideArray

int vtkObjectFactory::SizeOverrideArray
| protected

Definition at line 235 of file vtkObjectFactory.h.

## ◆ OverrideArrayLength

int vtkObjectFactory::OverrideArrayLength
| protected

Definition at line 236 of file vtkObjectFactory.h.

The documentation for this class was generated from the following file:

- Common/Core/vtkObjectFactory.h